' *******************************************************************************************************
' *                                                                                                     *
' *     AiChip_JVM_JemFile_001.spin                                                                     *
' *                                                                                                     *
' *******************************************************************************************************

PUB BytecodeStart

  return @JemBytecode

DAT

  JemBytecode FILE "jem.bin"

CON

  Jem_OPR_NONE          = 0
  Jem_OPR_BYTE          = 1
  Jem_OPR_TWO_BYTES     = 2
  Jem_OPR_WORD          = 2
  Jem_OPR_SIGNED_WORD   = 3
  Jem_OPR_BRANCH        = 3

  Jem_NOP               = $00
  Jem_ICONST_M1         = $01
  Jem_ICONST_0          = $02
  Jem_ICONST_1          = $03
  Jem_ICONST_2          = $04
  Jem_ICONST_3          = $05
  Jem_ICONST_4          = $06
  Jem_ICONST_5          = $07
  Jem_BIPUSH            = $08
  Jem_SIPUSH            = $09
  Jem_ILOAD             = $0A
  Jem_ILOAD_0           = $0B
  Jem_ILOAD_1           = $0C
  Jem_ILOAD_2           = $0D
  Jem_ILOAD_3           = $0E
  Jem_ISTORE            = $0F
  Jem_ISTORE_0          = $10
  Jem_ISTORE_1          = $11
  Jem_ISTORE_2          = $12
  Jem_ISTORE_3          = $13
  Jem_IFEQ              = $14
  Jem_IFNE              = $15
  Jem_IFLT              = $16
  Jem_IFLE              = $17
  Jem_IFGT              = $18
  Jem_IFGE              = $19
  Jem_IF_ICMPEQ         = $1A
  Jem_IF_ICMPNE         = $1B
  Jem_IF_ICMPLT         = $1C
  Jem_IF_ICMPGE         = $1D
  Jem_IF_ICMPGT         = $1E
  Jem_IF_ICMPLE         = $1F
  Jem_IF_ACMPEQ         = $20
  Jem_IF_ACMPNE         = $21
  Jem_IRETURN           = $22
  Jem_RETURN            = $23
  Jem_INVOKEVIRTUAL     = $24
  Jem_INVOKESTATIC      = $25
  Jem_GETSTATIC         = $26
  Jem_PUTSTATIC         = $27
  Jem_POP               = $28
  Jem_POP2              = $29
  Jem_DUP               = $2A
  Jem_DUP_X1            = $2B
  Jem_DUP_X2            = $2C
  Jem_DUP2              = $2D
  Jem_DUP2_X1           = $2E
  Jem_DUP2_X2           = $2F
  Jem_SWAP              = $30
  Jem_IADD              = $31
  Jem_ISUB              = $32
  Jem_INEG              = $33
  Jem_IOR               = $35
  Jem_ISHL              = $37
  Jem_ISHR              = $39
  Jem_IUSHR             = $3B
  Jem_IAND              = $3D
  Jem_IXOR              = $3F
  Jem_I2B               = $41
  Jem_GOTO              = $43
  Jem_INVOKEINTERFACE   = $45
  Jem_ARRAYLENGTH       = $47
  Jem_ATHROW            = $49
  Jem_CHECKCAST         = $4B
  Jem_INSTANCEOF        = $4D
  Jem_WIDE              = $4F
  Jem_IINC              = $51
  Jem_GETFIELD          = $53
  Jem_PUTFIELD          = $55
  Jem_NEW               = $57
  Jem_NEWARRAY          = $59
  Jem_ANEWARRAY         = $5B
  Jem_IALOAD            = $5D
  Jem_IASTORE           = $5F
  Jem_BALOAD            = $61
  Jem_BASTORE           = $63
  Jem_LDC               = $65
  Jem_LDC_W             = $67
  Jem_LDC2_W            = $69
  Jem_IMUL              = $6B
  Jem_IDIV              = $6D
  Jem_IREM              = $6F
  Jem_JSR               = $71
  Jem_RET               = $73
  Jem_TABLESWITCH       = $75
  Jem_LOOKUPSWITCH      = $77

PUB OpcodeNamePtr( opcode )

  if opcode < Jem_INSTANCEOF
  
    case opcode
      Jem_NOP:             result := String("NOP")
      Jem_ICONST_M1:       result := String("ICONST_M1")
      Jem_ICONST_0:        result := String("ICONST_0")
      Jem_ICONST_1:        result := String("ICONST_1")
      Jem_ICONST_2:        result := String("ICONST_2")
      Jem_ICONST_3:        result := String("ICONST_3")
      Jem_ICONST_4:        result := String("ICONST_4")
      Jem_ICONST_5:        result := String("ICONST_5")
      Jem_BIPUSH:          result := String("BIPUSH")
      Jem_SIPUSH:          result := String("SIPUSH")
      Jem_ILOAD:           result := String("ILOAD")
      Jem_ILOAD_0:         result := String("ILOAD_0")
      Jem_ILOAD_1:         result := String("ILOAD_1")
      Jem_ILOAD_2:         result := String("ILOAD_2")
      Jem_ILOAD_3:         result := String("ILOAD_3")
      Jem_ISTORE:          result := String("ISTORE")
      Jem_ISTORE_0:        result := String("ISTORE_0")
      Jem_ISTORE_1:        result := String("ISTORE_1")
      Jem_ISTORE_2:        result := String("ISTORE_2")
      Jem_ISTORE_3:        result := String("ISTORE_3")
      Jem_IFEQ:            result := String("IFEQ")
      Jem_IFNE:            result := String("IFNE")
      Jem_IFLT:            result := String("IFLT")
      Jem_IFLE:            result := String("IFLE")
      Jem_IFGT:            result := String("IFGT")
      Jem_IFGE:            result := String("IFGE")
      Jem_IF_ICMPEQ:       result := String("IF_ICMPEQ")
      Jem_IF_ICMPNE:       result := String("IF_ICMPNE")
      Jem_IF_ICMPLT:       result := String("IF_ICMPLT")
      Jem_IF_ICMPGE:       result := String("IF_ICMPGE")
      Jem_IF_ICMPGT:       result := String("IF_ICMPGT")
      Jem_IF_ICMPLE:       result := String("IF_ICMPLE")
      Jem_IF_ACMPEQ:       result := String("IF_ACMPEQ")
      Jem_IF_ACMPNE:       result := String("IF_ACMPNE")
      Jem_IRETURN:         result := String("IRETURN")
      Jem_RETURN:          result := String("RETURN")
      Jem_INVOKEVIRTUAL:   result := String("INVOKEVIRTUAL")
      Jem_INVOKESTATIC:    result := String("INVOKESTATIC")
      Jem_GETSTATIC:       result := String("GETSTATIC")
      Jem_PUTSTATIC:       result := String("PUTSTATIC")
      Jem_POP:             result := String("POP")
      Jem_POP2:            result := String("POP2")
      Jem_DUP:             result := String("DUP")
      Jem_DUP_X1:          result := String("DUP_X1")
      Jem_DUP_X2:          result := String("DUP_X2")
      Jem_DUP2:            result := String("DUP2")
      Jem_DUP2_X1:         result := String("DUP2_X1")
      Jem_DUP2_X2:         result := String("DUP2_X2")
      Jem_SWAP:            result := String("SWAP")
      Jem_IADD:            result := String("IADD")
      Jem_ISUB:            result := String("ISUB")
      Jem_INEG:            result := String("INEG")
      Jem_IOR:             result := String("IOR")
      Jem_ISHL:            result := String("ISHL")
      Jem_ISHR:            result := String("ISHR")
      Jem_IUSHR:           result := String("IUSHR")
      Jem_IAND:            result := String("IAND")
      Jem_IXOR:            result := String("IXOR")
      Jem_I2B:             result := String("I2B")
      Jem_GOTO:            result := String("GOTO")
      Jem_INVOKEINTERFACE: result := String("INVOKEINTERFACE")
      Jem_ARRAYLENGTH:     result := String("ARRAYLENGTH")
      Jem_ATHROW:          result := String("ATHROW")
      Jem_CHECKCAST:       result := String("CHECKCAST")

  else
    case opcode
    
      Jem_INSTANCEOF:      result := String("INSTANCEOF")
      Jem_WIDE:            result := String("WIDE")
      Jem_IINC:            result := String("IINC")
      Jem_GETFIELD:        result := String("GETFIELD")
      Jem_PUTFIELD:        result := String("PUTFIELD")
      Jem_NEW:             result := String("NEW")
      Jem_NEWARRAY:        result := String("NEWARRAY")
      Jem_ANEWARRAY:       result := String("ANEWARRAY")
      Jem_IALOAD:          result := String("IALOAD")
      Jem_IASTORE:         result := String("IASTORE")
      Jem_BALOAD:          result := String("BALOAD")
      Jem_BASTORE:         result := String("BASTORE")
      Jem_LDC:             result := String("LDC")
      Jem_LDC_W:           result := String("LDC_W")
      Jem_LDC2_W:          result := String("LDC2_W")
      Jem_IMUL:            result := String("IMUL")
      Jem_IDIV:            result := String("IDIV")
      Jem_IREM:            result := String("IREM")
      Jem_JSR:             result := String("JSR")
      Jem_RET:             result := String("RET")
      Jem_TABLESWITCH:     result := String("TABLESWITCH")
      Jem_LOOKUPSWITCH:    result := String("LOOKUPSWITCH")
      other:               result := String("Unknown")

